## QuickStarts

QuickStarts is a series of examples to get you started deploying and running applications with Fabric8.

The examples is categorized into a beginner section, and sections for experienced users. New users to Fabric8 is recommended to start with the beginner quickstarts.

Each QuickStart is documented as follows:

1. A brief description of the example
1. System requirements
1. How to build the example
1. How to run the example either using the command line or using the web console
1. How to try the example
1. How to uninstall the example
1. Optional suggested readings


### Beginner QuickStarts

The beginner quickstarts is located at

* [beginner](https://github.com/fabric8io/fabric8/tree/master/quickstarts/beginner)

First time users of Fabric is recommended to try the [Camel Content Based Router](https://github.com/fabric8io/fabric8/tree/master/quickstarts/beginner/camel-cbr) quickstart. 

### WebService and REST QuickStarts

There is a set of web service and REST quickstart that comes with and without security enabled.

* [SOAP](https://github.com/fabric8io/fabric8/tree/master/quickstarts/soap) - A SOAP web servie
* [SOAP secure](https://github.com/fabric8io/fabric8/tree/master/quickstarts/secure-soap) - A secured SOAP web servie

* [REST](https://github.com/fabric8io/fabric8/tree/master/quickstarts/rest) - A SOAP web servie
* [REST secure](https://github.com/fabric8io/fabric8/tree/master/quickstarts/secure-rest) - A secured SOAP web servie

There is also a REST quickstart deployable as a WAR into web containers such as Apache Tomcat, Jetty, or JBoss WildFly.

* [REST WAR](https://github.com/fabric8io/fabric8/tree/master/quickstarts/rest-war)

### JMS QuickStarts

There is a JMS example demonstrating using pure JMS Client API to connect to an existing A-MQ broker running in the fabric.

* [JMS Client](https://github.com/fabric8io/fabric8/tree/master/quickstarts/jms)
